import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Base class to put items which will be common to scratch.mit.edu sprites
 * 
 * @author Daniel Green <dang@sun.com>
 * @version 2009-09-09-09-49
 */

public class ScratchSprite  extends Actor
{
    /**
     * Act - do whatever the ScratchActor wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act() 
    {
        /** 
         * equivalent do "When Green Flag Clicked" + "forever" control
         * block in scratch
         */
    }    
    
    /* 
     * DARK BLUE "Motion" BLOCKS
     */
    
    /*
     * PURPLE "Looks" BLOCKS
     */
    
    public void move(double steps) {
        double angle = Math.toRadians( getRotation() );
        int x = (int) Math.round(getX() + Math.cos(angle) * steps);
        int y = (int) Math.round(getY() + Math.sin(angle) * steps);
       
        setLocation(x, y);        
    }
    
    public void turnRight(double degrees) {
        setRotation((int)((double)getRotation() + (double)degrees));
    }
    
    public void turnLeft(double degrees) {
        setRotation((int)((double)getRotation() - (double)degrees));
    }
    
    public void ifOnEdgeBounce() {
        /*
         * currently does nothing as greenfoot actors by default
         * don't go off screen
         */
    }
    
    /*
     * PINK "Sound" BLOCKS
     */
    
    /*
     * DARK GREEN "Pen" BLOCKS
     */
    
    /*
     * YELLOW "Control" BLOCKS
     */
    
    /*
     * LIGHT BLUE "Sensing" BLOCKS
     */
    
    /*
     * LIGHT GREEN "Operators" BLOCKS
     */
    
    /* 
     * ORANGE "Variables" BLOCKS
     */
} 
